.container {
	margin: 20px;
	display: grid;
	/* para crear nuestras columnas no es necesario decir cuantas queremos
    sino directamente asignar los anchos, aquí al asignar 3 anchos se crearán 3 columnas
    y podemos usar valores absolutos o relativos en el ancho de cada una */
	/* grid-template-columns: 200px 150px 20% 1fr; */
	/* Nota: Al definir una cantidad de renglones fija, no significa que no se pueda agregar más contenido, el nuevo contenido 
    agregado será un nuevo renglón con altura predefinida por defecto, en caso de que no se le asigne una altura al renglón
    por ejemplo aquí declaramos altura de 2 renglones pero podemos tener más renglones */
	/* En grid se pueden usar fracciones que son una forma de referirse al espacio sobrante, por ejemplo
    en la siguiente linea, definimos una columna de 200px, y otra de 20% del ancho, ademas de tener columnas que son fracciones,
    el espacio restante se va a dividir entre el numero de fracciones y se asignará segun corresponda, por ejemplo en este caso
    se dividirá entre 3 fracciones y se asignarán 2 a una columna y 1 a la otra */
	/* grid-template-columns: 200px 2fr 20% 1fr; */
	/* grid-template-rows: 5rem 2.5rem; */
	/* grid-template-rows: 5rem 2.5rem; */

	/* hay otro valor de css que podemos usar y es la unidad auto, esta define el tamaño de columna 
    o renglon de forma automática, aquí estamos asignando anchos de tamaño de columna fijos, y uno automático
    por lo que el automático tomará el espacio disponible restante para rellenar el contenido, de este modo
    cubriendo todo el ancho.
    Para definir la altura de los renglones, al usar auto no tendrá efecto al menos que tengamos una altura de grid definida
    por lo que en este ejemplo la asignamos a 600px, y con ello el segundo renglón tendrá la altura resultante de restar 5rem a los 600px,
    cabe mencionar que auto hace que la columna se ajuste al espacio que requiera su contenido, a diferencia de definir una altura o ancho
    fijo de renlgones y columnas */
	/* height: 600px; */
	/* background-color: yellow; */
	/* grid-template-columns: 200px 5rem 20% auto;
	grid-template-rows: 5rem auto; */

	/* height: 200px; */
	/* podemos usar la funcion repeat() de css grid, para repetir patrones en la asignacion
    de columnas o renglones, por ejemplo aquí se muestra un caso donde vamos a repetir 4 veces el patrón de asignar 
    una columna de 12.5%, una de 6.25% y otra de 6.25%, lo que nos dará al final en suma porcentual el 100%
    esto nos ayuda a ahorrar el escribir una y otra vez los mismos datos si tenemos patrones que se repiten */
	/* grid-template-columns: repeat(4, 12.5% 6.25% 6.25%); */
	/* muchas veces se usa para asignar 1fr o porcentajes que hagan que en conjunto sumen 100, como en este caso nos 
    creará 4 columnas que ocuparan todo el ancho pues cada una tendrá un 25% de ancho */
	/* cambiamos porcentajes por fr para que no haya problema con los gaps
    los porcentajes al asignarse no toman en cuenta los gaps, por loq ue en este caso el 100% del grid
    se le sumaría el valor de los gaps lo que haría que se desbordara, para solucionar esto cambiamos los porcentajes
    por fr */
	/* podemos asignar nombres a columnas o renglones, dentro de un repeat, simplemente ponemos
    el nombre como normalmente lo hacemos, antes y despues de las medidas en caso de que queramos
    asignar nombres tambien para las lineas iniciales y finales de cada renglón o columna */
	/* aqui usaremos otra funcion que incluye grid y es el inferir en base a los nombres que agreguemos a columnas
    y renglones las áreas, al rededor de todas las columnas que vamos a crear, vamos a agregar otro nombre
    en este caso será hd-start y hd end, usamos -start y -end porque de esta forma grid puede inferir los nombres que estan
    antes de ese valor y usarlos como nombres de columnas */
	grid-template-columns: [hd-start] repeat(4, [col-start] 20% [col-end]) [hd-end];
	/* podemos usar tambien la propiedad minmax(), esta nos ayuda a definir un rango de tamaño para cada columna, o renglón
    en el ejemplo que aqui se muestra, nuestra segunda columna solo puede tener un ancho que puede ir entre 10px y 200px.
    Al asignar un alto fijo de 200px al contenedor, y un tercer renglón que sea de 100 pixeles, nuestro segundo renglón tendrá que ser de 
    20 píxeles y aun así cumpliría el rango que le asignamos de medidas minimas y máximas
     */
	/* grid-template-rows: 5rem minmax(10px,200px) 100px; */
	/* en cambio si eliminamos nuestro tercer renglón teniendo ahora solo 2,
    nuestro segundo renglón puede tomar hasta 120px para cumplir aún con el rango que definimos, esto es util para limitar
    que tanto queremos que nuestras columnas se hagan pequeñas o grandes */
	height: 800px;

	/* podemos asignar nombres a las columnas o renglones y luego usar esos nombres
    para hacer referencias a las mismas en vez de los números, para asignarlas se pone
    el nombre antes del ancho que queremos que tenga esa columna, entre corchetes, por ejemplo aquí le asignamos
    el nombre de row-1-start al primer renglón, y despues asignamos el ancho, podemos asignar varios nombres
    a una línea, por ejemplo la  segunda es el final del primer renglón y el inicio del segundo
    así que podemos usar nombres alusivos a eso o cualquier nombre que nosotros prefiramos, y así sucesivamente */
	/* al momento de asignar los renglones, al primer renglon le asignamos el valor de hd-start y a su linea final le agregamos
    hd-end, recordar que todas las columnas tienen como nombre de la primer y última linea, el valor hd-start y hd-end respectivamente
    por lo que agregar como nombre el mismo valor a la primer y ultima linea del renglon hará que creemos un aréa inferida
    esto quiere decir que el área hd ocupará todo el primer renglón y como todas las columnas tienen hd-start al inicio y al final
    también tomará toda la primer columna, para hacer referencia a esta nueva área creada no hace falta agregar hd-start y end, 
    basicamente solo tenemos que agregar el nombre hd y con esto se hará referencia al renglón y columna corerctos */
	grid-template-rows:
		[hd-start] 5rem [hd-end row-2-start] minmax(10px, 20rem)
		[row-2-end row-3-start] 100px [row-3-end];

	/* otra propiedad que podemos agregar a nuestro grid son los gutters o espacios entre columnas y renglones
     estos espacios separan las lineas que comprenden nuestro grid, donde se marcan los inicios y finales de cada elemento
     si tenemos elementos que comprenden varias lineas o renglones y tenemos gaps sobre ellos, los elementos
     se posicionarán encima de dichos gaps    */
	/* Para asignar gap a columnas se hace de este modo indicando el espaciado que queremos
     haya en cada linea de las columnas del grid */
	/* grid-column-gap:20px;   
    /* Si por otra parte queremos asignar este espaciado a los renglones solo se cambia column por row
    y el funcionamiento es el mismo */
	/* grid-row-gap:10px;  */
	/* podemos usar solo grid-gap como atajo de ambos donde el primero asigna el gap
    de renglones, y el segundo de columnas */
	/* grid-gap: 10px 20px; */
	/* o simplemente poner un valor de gap que se aplicará a ambos, renglones y columnas */
	/* grid-gap: 20px; */
	/* aunque se recomienda usar gap que es la nueva forma de asignar esta propiedad */
	/* gap: 10px 20px; */
	gap: 10px;
	/* hay otra manera de asignar los elementos a las celdas de nuestro grid, y es usando grid-template areas 
    despues de que asignamos los renglones y columnas, ahora podemos agregar las áreas, que se podría decir que son una forma
    de nombrar las celdas de nuestro grid, asignando nombres que despues enlazaremos a nuestros elementos del grid
    y esos elementos ocuparán esas áreas */
	/* como se puede ver en el ejemplo, es similar a ver una tabla, tenemos 4 columnas y 3 renglones
    la primer columna tiene cuatro celdas cada una de nombre header, y la ultima 4 celdas 
    de nombre footer, cada una de esas celdas contiguas y con nombre, representa el espacio
    que utilizarán nuestros elementos, por ejemplo para el primer renglón tenemos que nuestro elemento
    utilizará 4 columnas, luego en el segundo renglon nuestro elemento side usará 2 y el main usará 2 tambien */
	/* Debemos tener cuidado de que cada renglon tenga la misma cantidad de celdas nombradas o ignoradas usando el . */
	grid-template-areas:
		'header header header header'
		'side side main main'
		/* podemos no asignar nombres a celdas simplemente
        poniendo puntos en vez de los nombres */
		/* '. . main main' */
		'footer footer footer footer';

	/*  */
	/* podemos alinear cada elemento de cada seccion o área de nuestro grid, parecido a como hacemos con flexbox
    usando las propiedades justify-items y align-items
    con justify item, alineamos el contenido de cada área de forma horizontal, es decir, hacia la izquierda o derecha
    y por otra parte con align-items alineamos el elemento de manera vertical es decir arriba o abajo
    por defecto ambos valores de justify y align seran stretch, lo que significa que el elemento ocupará todo
    el ancho y largo, hay un atajo para asignar ambas propiedades y es place-items que recibe como primer
    parametro el valor de align items y como segundo el de justify items, si solo se manda un valor
    se usará para ambos, funcionalidad muy util
     */
	/* justify-items: center; */
	/* justify-items: start; */
	/* justify-items: end; */
	/* justify-items: stretch; */
	/* align-items: center; */
	/* align-items: end; */
	/* align-items: end; */
	/* place-items: center; */
	/* place-items: end; */

	/* ademas de poder posicionar todos los elementos del grid con una linea, tambien
    podemos posicionar el grid como tal dentro de su contenedor, esto de posicionar se hace cuando 
    el contenido del grid, no llega a cubrir la totalidad del ancho y largo del grid
    Por ejemplo para ver con mas claridad esto, se disminuyeron los porcentajes de ancho de las columnas
    y la altura de los renglones para que no abarquen el 100% del ancho y largo del grid y se fijo un ancho y largo al grid
    una vez hecho esto, para posicionar la totalidad del contenido del grid dentro del propio contenedor grid, 
    se usan las propiedades justify content y align content */
	/* width: 800px; */
	/* Parecido a lo que hace justify items y align items, justify se encargará de alinear el contenido en
    su totalidad del grid y no a nivel de celda de manera horizontal dentro del grid, y por otra parte
    align se encargará de alinear verticalmente el contenido*/

	/* En el ejemplo que aquí se ve, estamos alineando con justify al centro y con align al final, lo que nos da 
    como resultado tener nuestro grid de manera centrada horizontalmente, y verticalmente al final del contenedor */
	/* justify-content: center; */
	/* El valor por defecto de justify es start por lo que estará al principio del contenedor */
	/* justify-content: center; */
	/* Notar que stretch no pareciera tener efecto en justify content, porque no modifica los anchos de las columnas
    que ya son fijas */
	/* justify-content: stretch; */
	/* align-content: end; */
}
/* podemos agregar responsividad a nuestra interfaz grid, modificando el orden en que aparecen los elementos
para este caso, cuando nuestro elemento sea menor a 40rem, agregaremos un nuevo renglón, a los 3 que tenemos
para que ahora sean 4, declarando de nuevo grid-template-rows vamos a sobreescribir los rows que ya tenemos, 
vamos a modificar la altura del ultimo, y agregaremos uno nuevo con alturas fijas
además de eso vamos a modificar las áreas del template para que ahora sidebar no esté al lado de main, sino mas bien
debajo, ya que no tendremos mucho espacio para poder colocar ambos elementos en el mismo renglón con pantalla 
reducida */

@media (max-width: 40rem) {
	.container{
		grid-template-rows:
		[hd-start] 5rem [hd-end row-2-start] minmax(10px, 20rem)
		[row-2-end row-3-start] 150px [row-3-end row-4-start] 100px;
		/* Entonces de este modo aprovechamos las bondades de css grid para cambiar nuestro template
		y poder colocar un elemento por renglón, se agrega un renglón nuevo porque side tendrá ahora su propio renglón
		y no compartirá renglón con main, limitandose esto de que compartan renglon
		a la interfaz de escritorio que será para resoluciones mayores a 40rem */
		grid-template-areas:
		'header header header header'
		'main main main main'
		'side side side side'
		'footer footer footer footer';
	}
}

.el1 {
	background: rgba(255, 154, 72, 0.5);
	/* para hacer uso de columnas nombradas mediante repeat además del nombre
    de la columna que queremos usar, debemos tambien agregar el número de coincidencia que queremos usar
    por ejemplo aquí queremos usar la segunda coincidencia del inicio de columna, y la segunda coincidencia del final de columna
    por tanto este elemento tomará un espacio apartir de la columna número 2, muy útil */
	/* grid-column: col-start 2 / col-end 2; */
	/* cambiamos nuestro elemento para que ahora se ajuste a un area y no a indices de nuestros templates */
	grid-area: side;
}

.el2 {
	background: rgba(255, 0, 0, 0.5);
	/* css grid hara que los elementos no hagan overlap por defecto,
    si por ejemplo aqui le indicamos que queremos que inicie en la primer columna hasta la última, se posicionará en un 
    nuevo renglón para no entrar en conflicto con el3 quue toma las mismas secciones del grid.
    Nota, podemos acceder al último renglón de un grid usando un -1 negativo ya que hay 2 formas de acceder
    a cada columna o renglón, usando sus números de línea de forma positiva o negativa que va de derecha a izquierda */
	/* grid-column-start: 1; */
	/* grid-column-end: 5; */
	/* grid-column-end: -1; */

	/* hay un atajo para poder usar las columnas y rows, para
    declarar donde inician y donde acaban, y es grid-column para columnas y grid-row para renglones
    en este ejemplo declaramos en que columna inicia el contenido, en este caso
    es en la primer columna, y ocupa todo el ancho ya que termina en la columna -1 que es la ultima o primera
    si lo vemos de izquierda a derecha
    */
	/* grid-column: 1 / -1; */

	/* para que nuestro elemento haga overlap con otro, (si es el comportamiento que deseamos)
    debemos decir especificamente eso, que queremos que por ejemplo en este caso la asignación de renglones del elemento
    del grid inicie en el renglón 2 que ya está ocupado por el elemento 3, de este modo
    ambos ocuparán la misma área, y se posicionara encima el que se haya  declarado despues*/

	/* para hacer referencia a un renglon o columna nombrado simplemente ponemos el nombre del renglón o columna
    en vez del índice o numero de la misma, por ejemplo aquí en vez de usar el renglón 2 usamos el nombre
    que le asignamos a ese renglón */
	/* grid-row-start: 2; */
	/* grid-row-start: row-2-start; */
	/* con los atajos de igual forma podemos usar span, y los nombres de variables
    en este caso asignamos que el contenido inicie en la variable row-2-start y se expanda 1, aunque podemos obviar esto ultimo porque es 
    el comportamiento por defecto */
	/* grid-row: row-2-start / span 1; */
	/* grid-row: row-2-start; */
	/* esto de abajo es el comportamiento por defecto así que sí solo queremos que se expanda un elemento una columna o
    renglón solo debemos especificar donde inicia */
	/* grid-row-end:span 1; */
	/* para modificar el orden en que se posiciona un elemento sobre otro podemos usar z-index, sin necesidad
    de especificar un valora  position, ya que grid por defecto es compatible con z-index */

	/* en este elemento para que se posicione sobre el espacio que asignamos con las areas
    simpplemente ponemos grid-area y como valor ponemos el nombre del area que usará de nuestro template
    con esto no hay necesidad de indicar que columnas o renglones usará, simplemente al asignar las areaas
    en nuestro grid, nuestro elemento ya sabe cual es su lugar */
	grid-area: main;

	z-index: 10;
	/* Parecido a lo que podemos hacer mediante el uso de flexbox, podemos  alinear individualmente el elemento que deseemos dentro de su
área del grid usando justify y align, para este ejemplo vamos a centrar vertical y horizontalmente el elemento el2 que es hijo
de nuestro grid-container */
	/* Recordar que justify-self nos ayuda a alinear el contenido, en este caso del área del grid, de manera horizontal y align-self
nos ayuda a alinearlo de manera vertical, al hacer esta alineacion se elimina la que viene por defecto que es stretch */
	/* justify-self: center;
	align-self: center; */
}

.el3 {
	background: rgba(0, 128, 0, 0.5);
	/* asignamos las posiciones en el grid que tomará el elemento, dentro del selector del elemento mismo,
    en este caso le asignamos el iniciar el la linea 3 del grid, y terminar en la linea 5.
    Al empezar en la linea 3 y terminar en la 5, tomará 2 columnas que son la 3 y 4, lo mismo al asignar el row, al asignar
    que inicie en la linea 1 y termine en la 3, tomará los renglones 1 y 2, si hay otro contenido que sea desplazado por esta signación
    se moverá en el sentido como si de texto se tratara, es decir de izquierda a derecha de arriba a abajo. */

	/* otra forma que tenemos de asignar las columnas o renglones, es indicar la columna o renglón
    inicial, e indicar cuantas columnas o renglones se va a expander, por ejemplo aquí le indicamos al elemento 3,
    que iniciará en la columna 2 y se expandirá para ocupar 3 lugares en total por lo que irá de la columna 2 a la 4 */
	/* grid-column-start: 2; */
	/* grid-column-end: 5; */
	/* grid-column-end: span 3; */
	/* cambiamos nuestros índices de renglones por los nombres que le asignamos a cada renglón */
	/* grid-row-start: 1; */
	/* grid-row-start: row-1-start; */

	/* grid-row-end: 3; */
	/* grid-row-end: row-2-end; */
	/* otro atajo un poco mas complejo de implementar es grid-area, en el podemos
    asignar en una sola linea, los inicios y finales de renglones y columnas separandolas por una 
    diagonal /, el primer valor será el renglon inicial del contenido, el segundo será
    la columa inicial, el tercero el renglon final, y el ultimo, el cuarto será la columna final
    de este modo asignamos todo el espacio que el elemento queremos que abarque dentro de
    nuestro contenedor grid */
	/* grid-area: row-1-start / 2 / row-2-end / span 3; */
	/* de igual forma para este elemento asignamos su área para que se pueda posicionar sin necesidad de definir columnas y renglones, esta
    es una forma más fácil de trabajar */
	/* grid-area: header; */
	/* hacemos referencia al área hd que está inferida por usar nombres de lineas con sufijos -start y -end */
	grid-area: hd;
}

.el4 {
	background: rgba(0, 4, 255, 0.5);
	grid-area: footer;
}

